#ifndef LOCALE
#define LOCALE

#define SHIFT 0x80
const uint8_t _asciimap[128] =
{
  0x00,     // NUL  0
  0x00,     // SOH  1
  0x00,     // STX  2
  0x00,     // ETX  3
  0x00,     // EOT  4
  0x00,     // ENQ  5
  0x00,     // ACK  6
  0x00,     // BEL  7
  0x2a,     // BS 8
  0x2b,     // TAB  9
  0x28,     // LF   10
  0x00,     // VT 11
  0x00,     // FF 12
  0x00,     // CR 13
  0x00,     // SO 14
  0x00,     // SI 15
  0x00,     // DEL  16
  0x00,     // DC1  17
  0x00,     // DC2  18
  0x00,     // DC3  19
  0x00,     // DC4  20
  0x00,     // NAK  21
  0x00,     // SYN  22
  0x00,     // ETB  23
  0x00,     // CAN  24
  0x00,     // EM 25
  0x00,     // SUB  26
  0x00,     // ESC  27
  0x00,     // FS 28
  0x00,     // GS 29
  0x00,     // RS 30
  0x00,     // US 31
  0x2c,     // ' '  32
  0x34 | SHIFT,   // !  33
  0x33 | SHIFT,   // "  34
  0x20,     // #  35 + AltGr
  0x21,     // $  36 + AltGr
  0x2d | SHIFT, // %  37
  0x24,     // &  38 + AltGr
  0x31 | SHIFT, // '  39
  0x30 | SHIFT, // (  40
  0x30,     // )  41
  0x25,     // *  42 + AltGr
  0x1e,     // +  43
  0x36,     // ,  44
  0x38,     // -  45
  0x37,     // .  46
  0x2f | SHIFT, // /  47
  0x27 | SHIFT, // 0  48
  0x1e | SHIFT, // 1  49
  0x1f | SHIFT, // 2  50
  0x20 | SHIFT, // 3  51
  0x21 | SHIFT, // 4  52
  0x22 | SHIFT, // 5  53
  0x23 | SHIFT, // 6  54
  0x24 | SHIFT, // 7  55
  0x25 | SHIFT, // 8  56
  0x26 | SHIFT, // 9  57
  0x37 | SHIFT, // :  58
  0x35,     // ;  59
  0x36,     // <  60 + AltGr
  0x2d,     // =  61
  0x37,     // >  62 + AltGr
  0x36 | SHIFT, // ?  63
  0x1f,     // @  64 + AltGr
  0x04 | SHIFT, // A  65
  0x05 | SHIFT, // B  66
  0x06 | SHIFT, // C  67
  0x07 | SHIFT, // D  68
  0x08 | SHIFT, // E  69
  0x09 | SHIFT, // F  70
  0x0a | SHIFT, // G  71
  0x0b | SHIFT, // H  72
  0x0c | SHIFT, // I  73
  0x0d | SHIFT, // J  74
  0x0e | SHIFT, // K  75
  0x0f | SHIFT, // L  76
  0x10 | SHIFT, // M  77
  0x11 | SHIFT, // N  78
  0x12 | SHIFT, // O  79
  0x13 | SHIFT, // P  80
  0x14 | SHIFT, // Q  81
  0x15 | SHIFT, // R  82
  0x16 | SHIFT, // S  83
  0x17 | SHIFT, // T  84
  0x18 | SHIFT, // U  85
  0x19 | SHIFT, // V  86
  0x1a | SHIFT, // W  87
  0x1b | SHIFT, // X  88
  0x1c | SHIFT, // Y  89
  0x1d | SHIFT, // Z  90
  0x2f,     // [  91 + AltGr
  0x31,     // bsl  92 + AltGr
  0x30,     // ]  93 + AltGr
  0x23,     // ^  94 + AltGr
  0x38 | SHIFT, // _  95
  0x35,     // `  96 + AltGr
  0x04,     // a  97
  0x05,     // b  98
  0x06,     // c  99
  0x07,     // d  100
  0x08,     // e  101
  0x09,     // f  102
  0x0a,     // g  103
  0x0b,     // h  104
  0x0c,     // i  105
  0x0d,     // j  106
  0x0e,     // k  107
  0x0f,     // l  108
  0x10,     // m  109
  0x11,     // n  110
  0x12,     // o  111
  0x13,     // p  112
  0x14,     // q  113
  0x15,     // r  114
  0x16,     // s  115
  0x17,     // t  116
  0x18,     // u  117
  0x19,     // v  118
  0x1a,     // w  119
  0x1b,     // x  120
  0x1c,     // y  121
  0x1d,     // z  122
  0x2f | SHIFT, // {  123 + AltGr
  0x31 | SHIFT, // |  124 + AltGr
  0x30 | SHIFT, // }  125 + AltGr
  0x35 | SHIFT, // ~  126 + AltGr
  0x00      // DEL  127
};
bool _altGrMap[128];
bool _altFine = false;

void initAltGr() {
  _altFine = true;

  _altGrMap[35] = true;
  _altGrMap[36] = true;
  _altGrMap[38] = true;
  _altGrMap[42] = true;
  _altGrMap[60] = true;
  _altGrMap[62] = true;
  _altGrMap[64] = true;
  _altGrMap[91] = true;
  _altGrMap[92] = true;
  _altGrMap[93] = true;
  _altGrMap[94] = true;
  _altGrMap[96] = true;
  _altGrMap[123] = true;
  _altGrMap[124] = true;
  _altGrMap[125] = true;
  _altGrMap[126] = true;
}

#endif
